#appendto Clonk

local speed = 0;
local ContactCalls=1;

local ActMap = {
	Float = {
		Prototype = Action,
		Name = "Float",
		Directions = 0,
		Procedure = DFA_FLOAT,
		Wdt = 8,
		Hgt = 8,
		Speed = 200,
		Length = 1,
		Delay = 0,
		NextAction = "Hold",
	}
};



public func InteractLadder(object ladder)
{
	if(GetAction()!="Float")	StartClimb(ladder);
	else EndClimb();
}

func StartClimb(object ladder)
{
	SetPosition(GetX()-(GetX()-ladder->GetX()), GetY());	
	SetXDir(0);
	SetAction("Float");
	AddEffect("LadderClimbControl", this, 50, 1, this);
	PlayAnimation("Scale", 5, Anim_Y(0, GetAnimationLength("Scale"), 0, 20), Anim_Const(1000));
	speed = GetYDir()/5;
	speed = speed * 50;
}

func FxLadderClimbControlTimer()
{
	var accel = 50;
	var maxspeed = 150;
	SetYDir(speed, 100);
	SetProperty("MeshTransformation", Trans_Rotate(-90, 0, 1, 0));
	if(GetComDir()) Sound("ladderstep?", false, RandomX(20, 40), nil, 0);
	else Sound("ladderstep?", false, 40, nil, -1);

	//___________UP__________//	
	
	if (GetComDir() == COMD_Up && Abs(speed) <= maxspeed)
	{
		speed=speed-accel;
	}
	
	if (GetComDir() == COMD_UpRight && Abs(speed) <= maxspeed)
	{
		EndClimb();
	}
	
	if (GetComDir() == COMD_UpLeft && Abs(speed) <= maxspeed)
	{
		EndClimb();
	}	

	//__________DOWN________//

	if (GetComDir() == COMD_Down && Abs(speed) <= maxspeed)
	{
		speed=speed+accel;
	}
	
	if (GetComDir() == COMD_DownRight && Abs(speed) <= maxspeed)
	{
		speed=speed+accel;
	}
	
	if (GetComDir() == COMD_DownLeft && Abs(speed) <= maxspeed)
	{
		speed=speed+accel;
	}
	
	//_____LEFT_AND_RIGHT_____//	
	
	if (GetComDir() == COMD_Left && Abs(speed) <= maxspeed)
	{
		EndClimb();
	}
	
	if (GetComDir() == COMD_Right && Abs(speed) <= maxspeed)
	{
		EndClimb();
	}
	
	if(!GetComDir() || Abs(speed)>maxspeed)
	{
		if(speed < 0) speed=speed+BoundBy(-speed, 0, +accel);
		if(speed > 0) speed=speed-BoundBy(speed, 0, +accel);
	}
		
	
	if(!FindObject(Find_ID(Ladder), Find_AtPoint()) || (!FindObject(Find_ID(Ladder), Find_AtPoint(0, 10))) && GetYDir() > 0)
	{
			EndClimb();
	}
	
	if(GBackSolid(0, -10) && GetComDir() == COMD_Up)
	{
		EndClimb();
	}
	
	if(GBackSolid(0, 10) && (GetComDir() == COMD_Down || GetComDir() == COMD_DownRight || GetComDir() == COMD_DownLeft))
	{
		EndClimb();
	}
	
	SetXDir(0);
}


public func EndClimb()
{
	speed = 0;
	Sound("ladderstep?", false, 40, nil, -1);
	RemoveEffect("LadderClimbControl", this);
	if (GetComDir() == COMD_UpRight || GetComDir() == COMD_Right)
	{
		SetXDir(8);
		SetYDir(-25);
		AddEffect("WallKick",this,1);
		SetAction("WallJump");
	}
	
	if (GetComDir() == COMD_UpLeft || GetComDir() == COMD_Left)
	{
		SetXDir(-8);
		SetYDir(-25);
		AddEffect("WallKick",this,1);
		SetAction("WallJump");

	}
	
	if(GetComDir() == COMD_Up)
	{
		SetYDir(-27);
		SetAction("Jump");
		SetDir(Random(1));
	}
	
	SetAction("Walk");
	Schedule(this, "SetProperty(\"MeshTransformation\", Trans_Rotate(180*GetDir(), 0, 1, 0))", 1,0);
	
}